/* 
 * Converting the image files to ota file format...
 * Copyright (C) 2005 by Alireza Naghizadeh
 * EMail: alireza_cpp@yahoo.com
 */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

namespace OTA_convert
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnConvert;
		private System.Windows.Forms.PictureBox pbMain;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pbMain = new System.Windows.Forms.PictureBox();
			this.btnConvert = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// pbMain
			// 
			this.pbMain.BackColor = System.Drawing.Color.White;
			this.pbMain.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pbMain.Location = new System.Drawing.Point(107, 24);
			this.pbMain.Name = "pbMain";
			this.pbMain.Size = new System.Drawing.Size(74, 30);
			this.pbMain.TabIndex = 0;
			this.pbMain.TabStop = false;
			// 
			// btnConvert
			// 
			this.btnConvert.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnConvert.Location = new System.Drawing.Point(107, 96);
			this.btnConvert.Name = "btnConvert";
			this.btnConvert.TabIndex = 1;
			this.btnConvert.Text = "Convert";
			this.btnConvert.Click += new System.EventHandler(this.btnConvert_Click);
			// 
			// Form1
			// 
			this.AllowDrop = true;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(288, 150);
			this.Controls.Add(this.btnConvert);
			this.Controls.Add(this.pbMain);
			this.MaximizeBox = false;
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "OTA Convertor";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.DragDrop += new System.Windows.Forms.DragEventHandler(this.Form1_DragDrop);
			this.DragEnter += new System.Windows.Forms.DragEventHandler(this.Form1_DragEnter);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.EnableVisualStyles();
			Application.DoEvents();
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
		}

		private void btnConvert_Click(object sender, System.EventArgs e)
		{
			if(pbMain.Image == null)
			{
				MessageBox.Show("First, Drag and drop a picture to this form.");
				return;
			}

			bool[,] ota = new bool[72,28];

			Bitmap bmp = (Bitmap)pbMain.Image;
			for(int y=0; y<28; y++)
				for(int x=0; x<72; x++)
				{
					if(bmp.GetPixel(x, y) == Color.FromArgb(0, 0, 0))
						ota[x,y] = false; // 0
					else
						ota[x,y] = true; // 1
				}
			SaveFileDialog dlg = new SaveFileDialog();
			dlg.Filter = "Nokia SMS (*.ota)|*.ota"  ;
			dlg.RestoreDirectory = true ;
			if(dlg.ShowDialog() != DialogResult.OK)
				return;
			FileStream fs = File.Open(dlg.FileName, FileMode.CreateNew);
			fs.WriteByte(0);
			fs.WriteByte(72);
			fs.WriteByte(28);
			fs.WriteByte(1);
			byte b = new byte();
			for(int y=0; y<28; y++)
				for(int c=0; c<9; c++)
				{
					b=0;
					for(int x=0; x<8; x++)
					{
						if(ota[c*8+x, y] == false)
							b += (byte)Math.Pow(2, 7-x);
					}
					fs.WriteByte(b);
				}
			fs.Close();
		}

		private void Form1_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			if (e.Data.GetDataPresent(DataFormats.FileDrop))
				e.Effect = DragDropEffects.Copy;
			else
				e.Effect = DragDropEffects.None;
		}

		private void Form1_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			string[] files = (string[])e.Data.GetData(DataFormats.FileDrop);
			pbMain.Image = new Bitmap(files[0]);
		}

	}
}
